!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! PROJECT:      The Computer Guy Clarion for Windows Tips           !
!               "Using the Media Control Interface"                 !
! MODULE:       MCITest.clw                                         !
! DESCRIPTION:  Media control interface test program                !
! COPYRIGHT:    Copyright  1996 - The Computer Guy                 !
!               http://www.compguy.com                              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  PROGRAM

  MAP
    MODULE('Windows')
      OMIT('***',_WIDTH32_)
      mciGetErrorString(ULONG,*CSTRING,USHORT),SHORT,PASCAL,RAW,PROC
      mciSendString(*CSTRING,*CSTRING,USHORT,USHORT),ULONG,PASCAL,RAW,PROC
      ***
      COMPILE('***',_WIDTH32_)
      mciGetErrorString(ULONG,*CSTRING,USHORT),SHORT,PASCAL,RAW,PROC,NAME('mciGetErrorStringA')
      mciSendString(*CSTRING,*CSTRING,USHORT,USHORT),ULONG,PASCAL,RAW,PROC,NAME('mciSendStringA')
      ***
    END
  END

mciRequestString        CSTRING(128)
mciReturnValue          CSTRING(128)
mciErrorNumber          LONG
mciErrorString          CSTRING(128)

HistoryQueue            QUEUE
mciRequestString          CSTRING(128)
                        END

Window WINDOW('Media Control Interface Tester'),AT(,,260,100),SYSTEM,GRAY,DOUBLE
       PROMPT('MCI &Request String:'),AT(5,5),USE(?mciRequestString:Prompt)
       COMBO(@s100),AT(80,5,175,10),USE(mciRequestString),DROP(10),FROM(HistoryQueue)
       PROMPT('MCI Return Value:'),AT(5,18),USE(?mciReturnValue:Prompt)
       ENTRY(@s100),AT(80,18,175,10),USE(mciReturnValue),DISABLE
       PROMPT('MCI Error Number:'),AT(5,31),USE(?mciErrorNumber:Prompt)
       ENTRY(@s100),AT(80,31,175,10),USE(mciErrorNumber),DISABLE
       PROMPT('MCI Error String:'),AT(5,44),USE(?mciErrorString:Prompt)
       ENTRY(@s100),AT(80,44,175,10),USE(mciErrorString),DISABLE
       BUTTON('mciSendString'),AT(5,82),USE(?ButtonSend),DEFAULT
       BUTTON('Close'),AT(225,82),USE(?ButtonClose)
     END

  CODE
  OPEN(Window)
  ACCEPT
    IF EVENT() = EVENT:CloseWindow THEN CYCLE.
    CASE ACCEPTED()
    OF ?ButtonSend
      CLEAR(mciReturnValue)
      CLEAR(mciErrorNumber)
      CLEAR(mciErrorString)
      mciSendString(mciRequestString,mciReturnValue,128,0)
      mciGetErrorString(mciErrorNumber,mciErrorString,128)
      HistoryQueue:mciRequestString = mciRequestString
      ADD(HistoryQueue,1)
      LOOP WHILE RECORDS(HistoryQueue) > 20
        GET(HistoryQueue,21)
        DELETE(HistoryQueue)
      END
      DISPLAY
      SELECT(?mciRequestString)
    OF ?ButtonClose
      BREAK
    END
  END
  CLOSE(Window)